<template>
  <div class="schedule-row">
    <div class="schedule-row__inputs">

      <datepicker-input class="schedule-row__input"
                        :error="showErrors && !rowInfo.date"
                        :date="rowInfo.date"
                        :disabledDates="disabledDates"
                        :disabledWeekdays="disabledWeekdays"
                        :alwaysDisabledWeekdays="alwaysDisabledWeekdays"
                        @changeDate="onChangeDate"
      />

      <base-select class="schedule-row__input schedule-row__input--time"
                   :class="{'schedule-row__input--visitors-show': rowInfo.visitors !== null}"
                   :options="filtredFromTimes.length ? filtredFromTimes : allFromTimes"
                   :error="showErrors && !rowInfo.timeFrom"
                   :value="rowInfo.timeFrom.value"
                   label="Время от"
                   noOptionsText="Нет свободного времени"
                   @onSelect="onSelectTime($event, 'from')"
      />

      <base-select class="schedule-row__input schedule-row__input--time"
                   :class="{'schedule-row__input--visitors-show': rowInfo.visitors !== null}"
                   :options="filtredToTimes.length ? filtredToTimes : allToTimes"
                   :error="showErrors && !rowInfo.timeTo"
                   :value="rowInfo.timeTo.value"
                   label="Время до"
                   noOptionsText="Нет свободного времени"
                   @onSelect="onSelectTime($event, 'to')"
      />

      <base-select class="schedule-row__input schedule-row__input--visitors-show"
                   v-if="isSelectWithVisitors !== null"
                   :options="isSelectWithVisitors"
                   :error="showErrors && !rowInfo.timeTo"
                   :value="rowInfo.visitors || isSelectWithVisitors[0]"
                   label="Посетители"
                   noOptionsText="Пусто"
                   @onSelect="onSelectVisitors($event)"
      />

      <div class="schedule-row__info" :class="{'schedule-row__input--visitors-show': rowInfo.visitors !== null}">
        <span class="schedule-row__price-old"
              v-if="rowInfo.price_old !== undefined && rowInfo.price_old !== null">
          {{ rowInfo.price_old | rubCurrency }}
        </span>
        <span class="schedule-row__price"
              v-if="rowInfo.date && rowInfo.timeFrom && rowInfo.timeTo">
          {{ rowInfo.price | rubCurrency }}
        </span>
        <span class="schedule-row__date">
          <template v-if="rowInfo.date">
            {{ dateValue(rowInfo.date) }}
          </template>

          <template v-if="rowInfo.date && rowInfo.timeFrom && rowInfo.timeTo">
            ,
          </template>

          <template v-if="rowInfo.timeFrom && rowInfo.timeTo">
            {{ timeCount | hours }}
          </template>
        </span>
      </div>

      <span class="schedule-row__remove" @click="removeRow">
        <icon-cross />
      </span>
    </div>

    <div class="schedule-row__btns" v-if="rowInfo.isOpen">
      <button type="button"
              class="schedule-row__btn button button--green"
              @click="saveRow"
      >Сохранить</button>
      <a href="javascript:void(0)"
         class="schedule-row__btn schedule-row__reset"
         @click="removeRow"
      >Отменить</a>
    </div>

  </div>
</template>

<script>
  import IconCross from './icons/IconCross';
  import DatepickerInput from './DatepickerInput';
  import BaseSelect from './BaseSelect';

  import { getFloatTime, getStringTime } from '../assets/js/helpers/formatTime';
  import { months } from '../assets/js/helpers/consts';

  export default {
    name: 'ScheduleRow',
    filters: {
      hours(value) {
        if (!value) return;

        if (value % 1 !== 0) {
          if (value < 5) {
            return `${value} часа`
          } else {
            return `${value} часов`
          }
        }

        if (value % 100 >= 5 && value % 100 <= 20) {
          return `${value} часов`
        } else if (value % 10 === 1) {
          return `${value} час`
        } else if (value % 10 === 2 || value % 10 === 3 || value % 10 === 4) {
          return `${value} часа`
        } else {
          return `${value} часов`
        }
      }
    },
    props: {
      rowInfo: {
        type: Object,
        required: true,
      },

      schedule: {
        type: Array,
        required: true,
      },

      scheduleItems: {
        type: Array,
        required: true,
      },

      minMaxTimes: {
        type: Object,
        required: true,
      },

      minDuration: {
        type: String,
        required: true,
      },

      quantise: {
        type: String,
        required: true
      },

      noOwnBookings: {
        type: Array,
        default() {
          return [];
        }
      },

      getNoWorkingHours: {
        type: Function,
        required: true
      },

      selectWithVisitors: {
        type: Function,
        required: true
      }
    },
    components: {
      BaseSelect,
      DatepickerInput,
      IconCross,
    },
    data: () => ({
      allFromTimes: [],
      allToTimes: [],
      filtredFromTimes: [],
      filtredToTimes: [],
      timeCount: null,
      showErrors: false,
      selectedInfo: [],
      disabledDates: [],
      alwaysDisabledWeekdays: [],
      disabledWeekdays: [],
      isDateChanged: false,
    }),
    mounted() {
      this.getAllTimes();

      this.selectedInfo = [ // Вставляет данные в сохранённый ROW
        ...this.scheduleItems.filter((scheduleItem) => scheduleItem.date),
        ...this.noOwnBookings
      ];

      this.alwaysDisabledWeekdays = this.getUnusedWeekdays(this.schedule);
    },
    computed: {
      minInterval() {
        let result = 0;
        const step = getFloatTime(this.quantise);
        const minDuration = getFloatTime(this.minDuration);

        for (let i = 0; i <= minDuration; i+=step) {
          result+=step;
        }

        return result;
      },

      isSelectWithVisitors() {
        if ((this.rowInfo.timeFrom !== '') && (this.rowInfo.timeTo !== '') && this.rowInfo.date) {
          return this.selectWithVisitors(this.rowInfo.timeFrom.value, this.rowInfo.timeTo.value, this.rowInfo.date)
        }

        return null
      }
    },
    methods: {
      getUnusedWeekdays(schedule, options = {}) {
        const timeFrom = options.timeFrom;
        const timeTo = options.timeTo;

        const weekNumbers = [1, 2, 3, 4, 5, 6, 7];
        let usedWeeks = [];
        let unusedWeeks = [];

        schedule.forEach((scheduleItem) => {
          if (timeFrom && (timeFrom < getFloatTime(scheduleItem.rules.from)
            || timeFrom + getFloatTime(this.minDuration) > getFloatTime(scheduleItem.rules.to))) return;
          if (timeTo && (timeTo > getFloatTime(scheduleItem.rules.to)
            || (timeTo - getFloatTime(this.minDuration)) < getFloatTime(scheduleItem.rules.from))) return;

          usedWeeks.push(...scheduleItem.rules.weekdays)
        });

        let fromInWeekdays = [];
        let toInWeekdays = [];

        schedule.forEach((scheduleItem) => {
          if (timeFrom >= getFloatTime(scheduleItem.rules.from)
            && timeFrom <= (getFloatTime(scheduleItem.rules.to) - getFloatTime(this.minDuration))) {
            fromInWeekdays.push(...scheduleItem.rules.weekdays);
          }

          if (timeTo >= (getFloatTime(scheduleItem.rules.from) + getFloatTime(this.minDuration))
            && timeTo <= getFloatTime(scheduleItem.rules.to)) {
            toInWeekdays.push(...scheduleItem.rules.weekdays)
          }
        });

        const fromInWeekdaysSet = Array.from(new Set(fromInWeekdays));
        const toInWeekdaysSet = Array.from(new Set(toInWeekdays));
        const fromAndToWeekdays = fromInWeekdaysSet.filter((weekday) => toInWeekdaysSet.includes(weekday));

        usedWeeks = fromAndToWeekdays.length ? fromAndToWeekdays : Array.from(new Set(usedWeeks));
        unusedWeeks = weekNumbers.filter((weekNumber) => !usedWeeks.includes(weekNumber));

        return unusedWeeks.map((unusedWeek) => unusedWeek + 1 > 7 ? unusedWeek + 1 - 7 : unusedWeek + 1);
      },

      saveRow() {
        if (this.rowInfo.date && this.rowInfo.timeFrom && this.rowInfo.timeTo) {
          this.$emit('saveRow', this.rowInfo.bookingId)
        } else {
          this.showErrors = true;
        }
      },

      removeRow() {
        this.$emit('removeRow', this.rowInfo.bookingId)
      },

      dateValue(value) {
        return `${value.getDate()} ${months[value.getMonth()]}`
      },

      getAllTimes() {
        const neededTimes = this.getTimesFromSchedule(this.schedule);

        this.allFromTimes = neededTimes.fromTimes;
        this.allToTimes = neededTimes.toTimes;
      },

      getTimesFromSchedule(schedule) {
        const fromTimes = [];
        const toTimes = [];

        schedule.forEach((scheduleItem, index) => {
          const isHasNoBreak = (toTimes.length ? toTimes[toTimes.length - 1].value : '') === getFloatTime(scheduleItem.rules.from);
          const isHasNoBreakFrom = getFloatTime(scheduleItem.rules.to) === (schedule[index + 1] ? getFloatTime(schedule[index + 1].rules.from) : '');

          const startTime = getFloatTime(scheduleItem.rules.from);
          const endTime = getFloatTime(scheduleItem.rules.to) || 24;

          for (let i = startTime; i <= endTime; i+=.5) {
            if (!fromTimes.filter((time) => time.value === i)[0]) {
              if (isHasNoBreakFrom || i <= (endTime - getFloatTime(this.quantise))) {
                fromTimes.push({ value: i, label: getStringTime(i) });
              }
            }

            if (!toTimes.filter((time) => time.value === i)[0]) {
              if (isHasNoBreak || i >= (startTime + getFloatTime(this.quantise))) {
                toTimes.push({ value: i, label: getStringTime(i === 24 ? 0 : i) })
              }
            }
          }
        });

        fromTimes.sort((a, b) => a.value > b.value ? 1 : a.value < b.value ? -1 : 0);
        toTimes.sort((a, b) => a.value > b.value ? 1 : a.value < b.value ? -1 : 0);

        return { fromTimes, toTimes };
      },

      onSelectTime(value, type) {
        let neededScheduleItems = [];
        let timesToFilterRepeat = null;

        neededScheduleItems = this.schedule.filter((scheduleItem) => {
          if (timesToFilterRepeat && timesToFilterRepeat.from === scheduleItem.rules.from
            && timesToFilterRepeat.to === scheduleItem.rules.to) return;

          timesToFilterRepeat = { from: scheduleItem.rules.from, to: scheduleItem.rules.to };

          return scheduleItem;
        });

        if (type === 'from') {
          if (this.rowInfo.date) {
            const noWorkingHours = this.getNoWorkingHours(this.rowInfo.date, this.schedule);

            if (noWorkingHours.length) {
              noWorkingHours.forEach((noWorkingHoursItem) => {

                if (value.value >= noWorkingHoursItem.to) return;

                neededScheduleItems = neededScheduleItems.filter((scheduleItem) => {
                  if (scheduleItem.rules.weekdays.includes(this.rowInfo.date.getDay() || 7)) {
                    return (getFloatTime(scheduleItem.rules.to) || 24) >= value.value + getFloatTime(this.quantise)
                      && (getFloatTime(scheduleItem.rules.from) <= noWorkingHoursItem.from - getFloatTime(this.quantise)
                      || getFloatTime(scheduleItem.rules.from) >= noWorkingHoursItem.to)
                      && getFloatTime(scheduleItem.rules.to) <= noWorkingHoursItem.from
                  }
                })

              });
            } else {
              neededScheduleItems = neededScheduleItems.filter((scheduleItem) => {
                if (scheduleItem.rules.weekdays.includes(this.rowInfo.date.getDay() || 7)) {
                  return (getFloatTime(scheduleItem.rules.to) || 24) >= value.value + getFloatTime(this.quantise)
                }
              })
            }
          }

          this.disabledWeekdays = this.getUnusedWeekdays(neededScheduleItems, { timeFrom: value.value, timeTo: this.rowInfo.timeTo.value });

          const neededTimes = this.getTimesFromSchedule(neededScheduleItems);

          this.filtredToTimes = neededTimes.toTimes.filter((time) => {
            const currentDateSelected = this.selectedInfo
              .filter((selectedItem) =>
                Number(this.rowInfo.date) === Number(selectedItem.date)
                && this.rowInfo.bookingId !== selectedItem.bookingId);

            const filtredByDateTimes = [];

            currentDateSelected.forEach((selectedItem) => {
              if (value.value < selectedItem.timeFrom.value
                && time.value <= selectedItem.timeFrom.value) {
                filtredByDateTimes.push(time.value)
              }

              if (value.value >= selectedItem.timeTo.value
                && time.value >= selectedItem.timeTo.value) {
                filtredByDateTimes.push(time.value)
              }
            });

            if (currentDateSelected.length) {
              return time.value > value.value
                && (time.value - value.value) >= getFloatTime(this.minDuration)
                && (time.value - value.value) % getFloatTime(this.quantise) === 0
                && filtredByDateTimes.includes(time.value);
            }

            return time.value > value.value
              && (time.value - value.value) >= getFloatTime(this.minDuration)
              && (time.value - value.value) % getFloatTime(this.quantise) === 0
            }
          );
        }

        if (type === 'to') {
          if (this.rowInfo.date) {
            const noWorkingHours = this.getNoWorkingHours(this.rowInfo.date, this.schedule);

            if (noWorkingHours.length) {
              noWorkingHours.forEach((noWorkingHoursItem) => {

                if (value.value >= noWorkingHoursItem.to) return;

                neededScheduleItems = neededScheduleItems.filter((scheduleItem) => {
                  if (scheduleItem.rules.weekdays.includes(this.rowInfo.date.getDay() || 7)) {
                    return getFloatTime(scheduleItem.rules.from) <= value.value - getFloatTime(this.minDuration)
                      && (getFloatTime(scheduleItem.rules.from) <= noWorkingHoursItem.from - getFloatTime(this.quantise)
                        || getFloatTime(scheduleItem.rules.from) >= noWorkingHoursItem.to)
                      && getFloatTime(scheduleItem.rules.to) <= noWorkingHoursItem.from
                  }
                })

              });

              neededScheduleItems = neededScheduleItems.filter((scheduleItem) => {
                return getFloatTime(scheduleItem.rules.from) <= value.value - getFloatTime(this.minDuration);
              });

            } else {
              neededScheduleItems = neededScheduleItems.filter((scheduleItem) => {
                if (scheduleItem.rules.weekdays.includes(this.rowInfo.date.getDay() || 7)) {
                  return getFloatTime(scheduleItem.rules.from) <= value.value - getFloatTime(this.minDuration)
                }
              })
            }
          }

          this.disabledWeekdays = this.getUnusedWeekdays(neededScheduleItems, { timeTo: value.value, timeFrom: this.rowInfo.timeFrom.value });

          const neededTimes = this.getTimesFromSchedule(neededScheduleItems);

          this.filtredFromTimes = neededTimes.fromTimes.filter((time) => {
            const currentDateSelected = this.selectedInfo
              .filter((selectedItem) =>
                Number(this.rowInfo.date) === Number(selectedItem.date)
                && this.rowInfo.bookingId !== selectedItem.bookingId);

            const filtredByDateTimes = [];

            currentDateSelected.forEach((selectedItem) => {
              if (value.value > selectedItem.timeTo.value
                && time.value >= selectedItem.timeTo.value) {
                filtredByDateTimes.push(time.value)
              }

              if (value.value <= selectedItem.timeFrom.value
                && time.value < selectedItem.timeFrom.value) {
                filtredByDateTimes.push(time.value)
              }
            });

            if (currentDateSelected.length) {
              return time.value < value.value
                && (value.value - time.value) >= getFloatTime(this.minDuration)
                && (value.value - time.value) % getFloatTime(this.quantise) === 0
                && filtredByDateTimes.includes(time.value);
            }

            return time.value < value.value
              && (value.value - time.value) >= getFloatTime(this.minDuration)
              && (value.value - time.value) % getFloatTime(this.quantise) === 0
          });
        }

        if (this.selectedInfo.length) {

          const busyTimes = [];

          this.selectedInfo.forEach((selectedItem) => {
            const currentBusyDate = busyTimes.filter((busyTime) => Number(busyTime.date) === Number(selectedItem.date))[0];

            if (currentBusyDate) {

              currentBusyDate.intervals.push({
                timeFrom: selectedItem.timeFrom,
                timeTo: selectedItem.timeTo
              })

            } else {

              busyTimes.push({
                date: selectedItem.date,
                intervals: [{
                  timeFrom: selectedItem.timeFrom,
                  timeTo: selectedItem.timeTo
                }]
              });

            }

            busyTimes.forEach((busyTime) => {

              let results = [];

              busyTime.intervals.forEach((interval) => {
                let result;

                if (type === 'from') {

                  if (!this.rowInfo.timeTo) {

                    result = value.value >= interval.timeFrom.value
                      && value.value < interval.timeTo.value;

                  } else {

                    result = (value.value >= interval.timeFrom.value && value.value < interval.timeTo.value)
                      || (value.value <= interval.timeFrom.value && this.rowInfo.timeTo.value >= interval.timeTo.value);

                  }

                }

                if (type === 'to') {

                  if (!this.rowInfo.timeFrom) {

                    result = value.value > interval.timeFrom.value
                      && value.value <= interval.timeTo.value

                  } else {

                    result = (value.value > interval.timeFrom.value && value.value <= interval.timeTo.value)
                      || (this.rowInfo.timeFrom.value <= interval.timeFrom.value && value.value >= interval.timeTo.value)
                      || (this.rowInfo.timeFrom.value < interval.timeTo.value && value.value >= interval.timeTo.value);

                  }
                }

                results.push(result);
              });

              const total = results.filter((result) => result)[0];

              if (total) {
                if (!this.disabledDates.includes(Number(busyTime.date))) {
                  this.disabledDates.push(Number(busyTime.date));
                }
              } else {
                this.disabledDates = this.disabledDates
                  .filter((disableDate) => disableDate !== Number(busyTime.date));
              }
            });
          });

        }

        this.$nextTick(() => {
          let price = 0;

          if (this.rowInfo.timeFrom && (this.rowInfo.timeTo || 24)) {
            this.timeCount = (this.rowInfo.timeTo.value || 24) - this.rowInfo.timeFrom.value;
          }

          for (let i = this.rowInfo.timeFrom.value; i < (this.rowInfo.timeTo.value || 24); i+=.5) {
            this.schedule.forEach((scheduleItem) => {
              const timeFrom = getFloatTime(scheduleItem.rules.from);
              const timeTo = getFloatTime(scheduleItem.rules.to) || 24;

              if ((i >= timeFrom && i < timeTo) && scheduleItem.rules.visitors &&
                (this.rowInfo.visitors >= scheduleItem.rules.visitors.min && this.rowInfo.visitors <= scheduleItem.rules.visitors.max)
              ) {
                price += scheduleItem.price / 2
              } else if ((i >= timeFrom && i < timeTo) && !scheduleItem.rules.visitors) {
                price += scheduleItem.price / 2
              }

            })
          }

          this.$emit('changePrice', { id: this.rowInfo.bookingId, price })
        });

        this.$emit('changeTime', {id: this.rowInfo.bookingId, type, value})
      },

      onSelectVisitors(value) {

        this.$nextTick(() => {
          let price = 0;

          if (this.rowInfo.timeFrom && (this.rowInfo.timeTo || 24)) {
            this.timeCount = (this.rowInfo.timeTo.value || 24) - this.rowInfo.timeFrom.value;

            for (let i = this.rowInfo.timeFrom.value; i < (this.rowInfo.timeTo.value || 24); i+=.5) {
              this.schedule.forEach((scheduleItem) => {
                const timeFrom = getFloatTime(scheduleItem.rules.from);
                const timeTo = getFloatTime(scheduleItem.rules.to) || 24;

                if ((i >= timeFrom && i < timeTo) && scheduleItem.rules.visitors &&
                  (value >= scheduleItem.rules.visitors.min && value <= scheduleItem.rules.visitors.max)
                ) {
                  price += scheduleItem.price / 2
                } else if ((i >= timeFrom && i < timeTo) && !scheduleItem.rules.visitors) {
                  price += scheduleItem.price / 2
                }
              })
            }
          }

          this.$emit('changePrice', { id: this.rowInfo.bookingId, price })
        });

        this.$emit('changeVisitors', { id: this.rowInfo.bookingId, value })
      },

      onChangeDate(event) {
        const choosedDateDay = event.getDay() || 7;
        const neededScheduleItems = this.schedule.filter((scheduleItem) =>
          scheduleItem.rules.weekdays.includes(choosedDateDay));
        const neededTimes = this.getTimesFromSchedule(neededScheduleItems);

        const neededSelectedItems = this.selectedInfo
          .filter((selectedItem) =>
            selectedItem.date.toLocaleDateString().substr(0, 10) === event.toLocaleDateString().substr(0, 10)
            && selectedItem.bookingId !== this.rowInfo.bookingId);

        let tmpFrom = [];
        let tmpTo = [];

        if (neededSelectedItems.length) {
          neededSelectedItems.forEach((selectedItem, index) => {

            if (index === 0) {
              tmpFrom = neededTimes.fromTimes.filter((time) =>
                (selectedItem.timeFrom.value - time.value) >= getFloatTime(this.minDuration)
                || time.value >= selectedItem.timeTo.value);

              tmpTo = neededTimes.toTimes.filter((time) =>
                time.value <= selectedItem.timeFrom.value ||
                (time.value - selectedItem.timeTo.value) >= getFloatTime(this.minDuration));

            } else {

              tmpFrom = tmpFrom.filter((time) =>
                time.value < selectedItem.timeFrom.value || time.value >= selectedItem.timeTo.value);

              tmpTo = tmpTo.filter((time) =>
                time.value <= selectedItem.timeFrom.value || time.value > selectedItem.timeTo.value);

            }
          });

          this.allFromTimes = tmpFrom;
          this.allToTimes = tmpTo;

          // если на момент выбора даты уже выбрано время
          // - нужно отфильтровать допустимый выбор времени с учетоем выбора даты
          this.selectedInfo = [
            ...this.scheduleItems.filter((scheduleItem) => scheduleItem.date),
            ...this.noOwnBookings
          ];

          if (this.rowInfo.timeFrom) this.onSelectTime(this.rowInfo.timeFrom, 'from');
          if (this.rowInfo.timeTo) this.onSelectTime(this.rowInfo.timeTo, 'to');
        } else {
          this.allFromTimes = neededTimes.fromTimes;
          this.allToTimes = neededTimes.toTimes;

          this.$nextTick(() => {
            if (this.rowInfo.timeFrom) this.onSelectTime(this.rowInfo.timeFrom, 'from');
            if (this.rowInfo.timeTo) this.onSelectTime(this.rowInfo.timeTo, 'to');
          });
        }

        if (event) {
          this.$emit('changeDate', {id: this.rowInfo.bookingId, value: event})
        }
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .schedule-row {
    padding: rem(28) 0;
    border-bottom: rem(1) solid #DCE2EF;

    @media (max-width: $mobile-width) {
      padding: rem(34) 0 rem(28);
    }

    &__inputs {
      display: flex;
      align-items: center;

      @media (max-width: $mobile-width) {
        flex-flow: wrap;
        justify-content: space-between;
      }
    }

    &__input {
      & + & {
        margin-left: rem(28);

        &--visitors-show {
          margin-left: rem(10);
        }
      }

      width: rem(170);

      @media (max-width: $mobile-width) {
        & + & {
          margin-left: 0;
          margin-top: rem(16);
        }

        width: 100%;

        &--time {
          width: calc(50% - .5rem);
        }
      }
    }

    &__info {
      margin-left: rem(28);

      display: flex;
      flex-flow: column;

      @media (max-width: $mobile-width) {
        width: 100%;
        margin-left: 0;
        margin-top: rem(20);

        flex-flow: row;
        align-items: center;
        justify-content: space-between;
      }
    }

    &__price {
      @include p1;

      @media (max-width: $mobile-width) {
        font-size: rem(18);
      }
    }

    &__price-old {
      @include p3;
      color: rgba($black, .6);
      text-decoration: line-through;
    }

    &__date {
      @include p3;
      color: rgba($black, .6);

      @media (max-width: $mobile-width) {
        font-size: rem(14);
      }
    }

    &__remove {
      margin-left: auto;
      margin-right: rem(-8);
      padding: rem(2) rem(8);

      cursor: pointer;

      svg {
        transition: all .35s;
      }

      &:hover {
        svg {
          stroke: $black;
        }
      }

      @media (max-width: $mobile-width) {
        position: absolute;
        top: rem(-28);
        right: rem(2);

        svg {
          width: rem(12);
          height: rem(12);
        }
      }
    }

    &__btns {
      display: flex;
      align-items: center;

      margin-top: rem(28);

      @media (max-width: $mobile-width) {
        justify-content: space-between;
      }
    }

    &__btn {
      & + & {
        margin-left: rem(36);

        @media (max-width: $mobile-width) {
          margin-left: 0;
        }
      }

      @media (max-width: $mobile-width) {
        flex: 0 0 calc(50% - .5rem);
        width: calc(50% - .5rem);
      }
    }

    &__reset {
      @include bold-black-link;
      color: rgba($black, .4);
      transition: color .25s;

      &:hover {
        color: black;
      }
    }

  }
</style>
